package demos;

/*
 * File: Checkerboard.java
 */

import acm.graphics.*;
import acm.program.*;

@SuppressWarnings("serial")
public class Checkerboard extends GraphicsProgram {

	private static final int NROWS = 8;

	private static final int NCOLS = 10;

	// Minimal whitespace around the checkerboard
	private static final int REVEAL = 10;

	public void run() {

		int sqSize = Math.min((getHeight() - 2 * REVEAL) / NROWS,
				(getWidth() - 2 * REVEAL) / NCOLS);

		for (int i = 0; i < NROWS; i++) {
			for (int j = 0; j < NCOLS; j++) {
				int x = j * sqSize + REVEAL;
				int y = i * sqSize + REVEAL;
				GRect sq = new GRect(x, y, sqSize, sqSize);
				sq.setFilled((i + j) % 2 != 0);
				add(sq);
			}
		}

	}

}
