package demos;

import acm.program.*;

@SuppressWarnings("serial")
public class LogicOps extends ConsoleProgram {
	
	// variables local to the run method,
	// parameters passed to the checkDivisibility methods

	public void run() {

		println("This program takes two integers and determines "
				+ "whether the first is divisible by the second.");
		int x = readInt("Enter the first integer: ");
		int y = readInt("Enter the second integer: ");
		
		checkDivisbilityVersion1(x, y);

	}

	// This method has a bug
	private void checkDivisbilityVersion1(int a, int b) {

		if (a % b == 0) {
			println(a + " is divisible by " + b + ".");
		} else {
			println(a + " is not divisible by " + b + ".");
		}
	}

	// This method fixes the bug, but awkwardly
	private void checkDivisbilityVersion2(int a, int b) {

		if (b != 0) {
			if (a % b == 0) {
				println(a + " is divisible by " + b + ".");
			} else {
				println(a + " is not divisible by " + b + ".");
			}
		} else {
			println(a + " is not divisible by " + b + ".");
		}
	}

	// This method tries to solve the problem more nicely,
	// but it has a bug
	private void checkDivisbilityVersion3(int a, int b) {

		if ((a % b == 0) && (b != 0)) {
			println(a + " is divisible by " + b + ".");
		} else {
			println(a + " is not divisible by " + b + ".");
		}
	}

	// This method takes advantage of "short circuiting"
	// to correct the bug
	private void checkDivisbilityVersion4(int a, int b) {

		if ((b != 0) && (a % b == 0)) {
			println(a + " is divisible by " + b + ".");
		} else {
			println(a + " is not divisible by " + b + ".");
		}
	}

}
